#include "Arduino.h"
#include "_74595_matrix.h"
#include "MatrixFont.h"

matrix::matrix(byte data,byte latch,byte clock,byte matrises)
{
	pinMode(data,OUTPUT);
		pinMode(latch,OUTPUT);
	pinMode(clock,OUTPUT);
	_data=data;
	_latch=latch;
	_clock=clock;
	_matrises=matrises;
}


void matrix::matrixDraw() //draw loop,DON'T TOUCH!
{
  setcolumn(_displayPointer);            //column scanning
  setdata(_buffer1[_displayPointer]);    //bit banging shift registers
  digitalWrite(_latch, LOW);
  digitalWrite(_latch, HIGH);

  if (++_displayPointer == _matrises*8)          //32 LED row sections in total
  { _displayPointer = 0;
  }
}



void matrix::setcolumn(byte col)         //loop that takes care of column scanning DON'T TOUCH!
{
  for (_pos = _matrises*8; _pos > -1; _pos--)
  {
    if (col == _pos)
    {
      digitalWrite(_data, HIGH);
    }
    else
    {
      digitalWrite(_data, LOW);

    }
    digitalWrite(_clock, HIGH);
    digitalWrite(_clock, LOW);

  }
}


void matrix::setdata(byte dat)
{
  for (_pos = 0; _pos < 8; _pos++)
  {
    if (dat & 128)
    {
      dat -= 128;
      digitalWrite(_data, HIGH);

    }
    else
    {
      digitalWrite(_data, LOW);

    }
    dat = dat << 1;  //dat <<1==dat *2;
    digitalWrite(_clock, HIGH);
    digitalWrite(_clock, LOW);

  }
}




void matrix::matrixClr()                          //clear display buffer
{
  for (_addr = 0; _addr < _matrises*8; _addr++) // Empty display buffer
    _buffer1[_addr] = 0;
}

void matrix::matrixPixel(signed char x, signed char y, byte cond)
{
  if (x < 0 || y < 0)
  {
    return; // outside drawing limits negative
  }
  if (x > _matrises*8-1 || y > 7)
  {
    return; // outside drawing limits positive, x=32, y=8
  }
  _pix = _power[y];
  _msk = _buffer1[x]; // get exsisting data


  if (cond == 2)
    _pix ^= _msk; //XOR data to screen
  if (cond == 1)
  {
    _pix = ~_pix;
    _pix &= _msk; // AND data to screen
  }
  if (cond == 0)
    _pix |= _msk; // OR data to screen
  _buffer1[x] = _pix; // apply changes
}




void matrix::matrixValue(char ch, signed char x, signed char y, byte rotation)
{

  for ( _x1 = 0; _x1 < 8; _x1++)
  {
    _disp = matrixFont[_x1 + (ch << 3)];
    for (_y1 = 0; _y1 < 8; _y1++)
    {
      _disp2 = _disp & _power[_y1];
      if (_disp2 > 0)
      {
        if (rotation == 0)
        {
          matrixPixel(x + _x1, y + _y1, 0); //0 degrees
        }
        if (rotation == 1)
        {
          matrixPixel(7 - (y + _y1), (x + _x1), 0); //90 degrees, flip to left
        }
        if (rotation == 2)
        {
          matrixPixel(7 - (x + _x1), 7 - (y + _y1), 0);
        }
        if (rotation == 3)
        {
          matrixPixel(y + _y1, 7 - (x + _x1), 0); //90 degrees, flip to right
        }
      }
    }
  }
}





void matrix::matrixText(char* ch, signed char x, signed char y, byte rotation)  //strput relies on charput
{
  while (*ch )
  {
    matrixValue(*ch++, x, y, rotation); //write a string to the display buffer
    x += 7;
  }
}
